"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class InterpretedGenomeInject(ProtocolElement):
    """
    Record for tiered variant injection as part of the data intake for CVA
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "interpretedGenome",
        "metadata",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_11 import cva as cva_1_5_3
        from protocols.protocol_7_11 import reports as reports_6_4_0

        return {
            "interpretedGenome": reports_6_4_0.InterpretedGenome,
            "metadata": cva_1_5_3.InjectionMetadata,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_11 import cva as cva_1_5_3
        from protocols.protocol_7_11 import reports as reports_6_4_0

        return {
            "org.gel.models.report.avro.InterpretedGenome": reports_6_4_0.InterpretedGenome,
            "org.gel.models.cva.avro.InjectionMetadata": cva_1_5_3.InjectionMetadata,
            "org.gel.models.cva.avro.InterpretedGenomeInject": cva_1_5_3.InterpretedGenomeInject,
        }

    __slots__ = [
        "interpretedGenome",
        "metadata",
    ]

    def __init__(
        self,
        interpretedGenome,
        metadata,
        validate=None,
        **kwargs
    ):
        """Initialise the cva_1_5_3.InterpretedGenomeInject model.

        :param interpretedGenome:
            Rare disease Interpreted Genome
        :type interpretedGenome: InterpretedGenome
        :param metadata:
            Metadata on the report events in the interpreted genome
        :type metadata: InjectionMetadata
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.5.3"
